import * as types from "./actionTypes";
import initialState from "../../redux/reducers/initialState";
import { botType } from "./constants";

export default function chatbotReducer(state = initialState.bot, action) {
  switch (action.type) {
    case types.SUMMON_WIZARD:
      return { ...state, type: botType.wizard };

    case types.DISMISS_BOT:
      return { ...state, type: botType.none };

    case types.INITIALIZE_BOT_SESSION_STARTED:
      return { ...state, session: { loading: true, loaded: false } };

    case types.INITIALIZE_BOT_SESSION_SUCCESS:
      return {
        ...state,
        session: { loading: false, loaded: true, ...action.payload }
      };

    case types.INITIALIZE_BOT_CHAT_STARTED:
      return { ...state, chat: { loading: true, loaded: false } };

    case types.INITIALIZE_BOT_CHAT_SUCCESS:
      return {
        ...state,
        chat: { loading: false, loaded: true, ...action.payload }
      };

    default:
      return state;
  }
}
